@echo off
:: Silent install batch script. All configuration settings belong in oposiSeries.ini 

:: old install already present?
@echo Searching for previous 'OPOS for the Ingenico iSeries' installations...
call cscript //B IsOPOSPresent.vbs
if exist hasOPOS.tmp goto UNINSTALL
@echo No previous installations found.
GOTO PRECONFIG

:UNINSTALL
@echo Previous version found. Uninstalling...
call "silent uninstall"
@del hasOPOS.tmp
GOTO PRECONFIG

:PRECONFIG
:: Determine which components to install
call "silent install options"
@echo off

:: Now that options are specified, we can determine the download info location
echo [Download] >tmp.ini
echo DownloadInfoFile=%TARGET%\download.ini >>tmp.ini

:: also set up IBM EFT Executable Location
echo IBM EFT Executable=%TARGET%\ibmeftdl.exe >>tmp.ini

:: and CHFormNumber
echo CHFormNumber=255 >>tmp.ini

:: create temporary install settings
copy /y "Silent Install Settings.iss" tmp.iss

:: number of components
SET COUNT=0

:: assume no form entries needed
SET PUSH_FORM_ENTRIES=NO

:SETALLUSERS_TRUE
IF %ALL_USERS%==NO goto SETALLUSERS_FALSE
SET ALL_USER_SEL_1=0
SET ALL_USER_SEL_2=1
GOTO CONFIG
:SETALLUSERS_FALSE
SET ALL_USER_SEL_1=1
SET ALL_USER_SEL_2=0
GOTO CONFIG

:CONFIG
if %INGENICO_CTRLS%==YES goto ADD_1
if %OPOS_CONTROLS%==YES goto ADD_2
if %CTRL_PANEL_APP%==YES goto ADD_3
if %OPOS_SERVICES%==YES goto ADD_4
echo szDir=%TARGET% >>tmp.iss
echo Component-count=%COUNT% >>tmp.iss
echo Result=1 >>tmp.iss
echo [{BA6BE264-85D6-49AB-8C05-0B532131BD43}-SdAskDestPath2-0] >>tmp.iss
echo szDir=%TARGET% >>tmp.iss
echo Result=1 >>tmp.iss
echo [{BA6BE264-85D6-49AB-8C05-0B532131BD43}-AskOptions-0] >>tmp.iss
echo Result=1 >>tmp.iss
echo Sel-0=%ALL_USER_SEL_1% >>tmp.iss
echo Sel-1=%ALL_USER_SEL_2% >>tmp.iss

GOTO INSTALL
 
:ADD_1
echo Component-%COUNT%=Ingenico-specific Controls >>tmp.iss
SET /A COUNT=%COUNT%+1
SET INGENICO_CTRLS=""
SET PUSH_FORM_ENTRIES=YES
GOTO CONFIG

:ADD_2
echo Component-%COUNT%=OPOS Control Objects >>tmp.iss
SET /A COUNT=%COUNT%+1
SET OPOS_CONTROLS=""
GOTO CONFIG

:ADD_3
echo Component-%COUNT%=Control Panel Application >>tmp.iss
SET /A COUNT=%COUNT%+1
SET CTRL_PANEL_APP=""
GOTO CONFIG

:ADD_4
echo Component-%COUNT%=OPOS Service Objects for the Ingenico iSeries >>tmp.iss
SET /A COUNT=%COUNT%+1
SET OPOS_SERVICES=""
GOTO CONFIG

:INSTALL
@echo Performing silent installation of OPOS for the Ingenico iSeries
@"OPOS for the Ingenico iSeries" /s /f1"%CD%\tmp.iss" 
@echo Installshield portion complete. Updating system registry with oposiSeries.ini
@regpusher oposiSeries.ini Connection SOFTWARE\OLEforRetail\ServiceOPOS\SignatureCapture\Ing6XXX
@regpusher oposiSeries.ini LineDisplay SOFTWARE\OLEforRetail\ServiceOPOS\LineDisplay\Ing6XXX REG_SZ
@regpusher oposiSeries.ini MSR SOFTWARE\OLEforRetail\ServiceOPOS\MSR\Ing6XXX
@regpusher oposiSeries.ini PINPad SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX
@regpusher oposiSeries.ini POSKeyboard SOFTWARE\OLEforRetail\ServiceOPOS\POSKeyboard\Ing6XXX
@regpusher oposiSeries.ini SignatureCapture SOFTWARE\OLEforRetail\ServiceOPOS\SignatureCapture\Ing6XXX
@regpusher oposiSeries.ini Download SOFTWARE\OLEforRetail\ServiceOPOS\SignatureCapture\Ing6XXX
@regpusher tmp.ini Download SOFTWARE\OLEforRetail\ServiceOPOS\SignatureCapture\Ing6XXX
@echo Updating system registry with PINPrompts.ini
@regpusher PINPrompts.ini 6550_Lang9  SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6550\Lang9
@regpusher PINPrompts.ini 6550_Lang10 SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6550\Lang10
@regpusher PINPrompts.ini 6510_Lang9  SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6510\Lang9
@regpusher PINPrompts.ini 6510_Lang10 SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6510\Lang10
@regpusher PINPrompts.ini 6770_Lang9  SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6770\Lang9
@regpusher PINPrompts.ini 6770_Lang10 SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6770\Lang10
@regpusher PINPrompts.ini 6580_Lang9  SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6580\Lang9
@regpusher PINPrompts.ini 6580_Lang10 SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6580\Lang10
@regpusher PINPrompts.ini 6780_Lang9  SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6780\Lang9
@regpusher PINPrompts.ini 6780_Lang10 SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\6780\Lang10
@regpusher PINPrompts.ini 3070_Lang9  SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\3070\Lang9
@regpusher PINPrompts.ini 3070_Lang10 SOFTWARE\OLEforRetail\ServiceOPOS\PINPad\Ing6XXX\Prompts\3070\Lang10
@echo Updating system registry with CLSIDs for Service Objects
@regedit /s CLSID.reg

:DOWNLOAD
:: Based on EFT download option setting, create the appropriate download file
del /q /f "%TARGET%\download.ini"
if %EFT_DOWNLOAD%==YES goto DL_YES
if %EFT_DOWNLOAD%==NO goto DL_NO
:DL_YES
echo EFTDownloadNeeded=1 >"%TARGET%\download.ini"
goto DL_DONE
:DL_NO
echo EFTDownloadNeeded=0 >"%TARGET%\download.ini"
goto DL_DONE
:DL_DONE
if %PUSH_FORM_ENTRIES%==YES goto FORMPUSH
GOTO CLEANUP

:FORMPUSH
@regpusher oposiSeries.ini IVICMForm SOFTWARE\OLEforRetail\ServiceOPOS\IVICMForm\Ing6XXX
GOTO CLEANUP

:CLEANUP
del tmp.iss
del tmp.ini
SET TARGET=
SET COUNT=
SET PUSH_FORM_ENTRIES=

@echo on
@echo Silent installation complete.

